//genMethods "-g" "-t" "AttributeBase" "-I" "LINK/graph/Attribute.h" "-d" "graph" "-y" "display_attribute" "-w" "free_attribute" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>
#include <LINK/graph/Attribute.h>
#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
void display_attribute(SCM, SCM, int);
void free_attribute(SCM);
typedef AttributeBase _AttributeBase;
#define _AttributeBaseDATA(x) ((AttributeBase*) (EXTDATA(x)))
#define _AttributeBaseIS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<AttributeBase >::type))
#define _AttributeBaseISNT_DATA(x) (!IS_DATA(x))
#define _AttributeBaseCXX_DATA(x) (*(AttributeBase*) (EXTDATA(VAL(x))))
#define _AttributeBaseCXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<AttributeBase >::type))
#define _AttributeBaseCXX_ISNT_DATA(x) (!CXX_IS_DATA(x))
#include<strstream.h>
void free_attribute(SCM p)
{
        //cout << "free_attribute" << endl;
        if (!EXTSTATICP(p))
                Register<AttributeBase>::deleteEntry(_AttributeBaseDATA(p));
}
void display_attribute(SCM c, SCM port, int mode)
{
        ostrstream oss;
        if (_AttributeBaseDATA(c))
                oss << *_AttributeBaseDATA(c);
	//ElementOps<AttributeBase>::displayItem(oss, _AttributeBaseDATA(c));
        oss << ends;
        char *buffer = oss.str();
        Puts(buffer, (port));
        delete buffer;
}
// define your new methods above 
// and register them using STk_add_new_cpp_primitive() below
void genExtra_AttributeBaseMethods() {}
